/*
   This is an example of a class that contains an array.

   This class encapsulates the idea of an "infinitely long" array. Of
   course, an array cannot be inifinitely long, so this object creates
   the illusion of infinite length by making the object look like a
   periodic array, that is, an array whose entries keep repeating
   every 10 indices.

   This class is an example of what is called an "abstract data type". This
   class appears to be defining a new kind of data type, the type of an
   inifinitely long (periodic) array.
*/
#include "InfiniteArray.h"

InfiniteArray::InfiniteArray()
{
   period = 10;
}

/*
   Put a value in the InfiniteArray object at "location" i.
*/
void InfiniteArray::setEntry(int i, int value)
{
   int j = i % period;
   hiddenArray[j] = value;
}


/*
   Put a value in the InfiniteArray object at "location" i.
*/
void InfiniteArray::setEntry(long i, int value)
{
   int j = (int)(i % (long)period);
   hiddenArray[j] = value;
}


/*
   Get the value stored at "location" i.
*/
int InfiniteArray::getEntry(int i)
{
   int j = i % period;
   return hiddenArray[j];
}


/*
   Get the value stored at "location" i.
*/
int InfiniteArray::getEntry(long i)
{
   int j = (int)(i % (long)period);
   return hiddenArray[j];
}

/*
   Return the period of the infinitly long array.
*/
int InfiniteArray::getPeriod()
{
   return period;
}

