/*
   This is an example of a class that contains an array.

   This class encapsulates the idea of an "infinitely long" array. Of
   course, an array cannot be inifinitely long, so this object creates
   the illusion of infinite length by making the object look like a
   periodic array, that is, an array whose entries keep repeating
   every 10 indices.

   This class is an example of what is called an "abstract data type". This
   class appears to be defining a new kind of data type, the type of an
   inifinitely long (periodic) array.
*/

class InfiniteArray
{
   public:
   InfiniteArray();

   /*
      Put a value in the InfiniteArray object at "location" i.
   */
   void setEntry(int i, int value);

   /*
      Put a value in the InfiniteArray object at "location" i.
   */
   void setEntry(long i, int value);

   /*
      Get the value stored at "location" i.
   */
   int getEntry(int i);

   /*
      Get the value stored at "location" i.
   */
   int getEntry(long i);

   /*
      Return the period of the infinitly long array.
   */
   int getPeriod();

   private:
   // An instance reference variable.
   int period;
   int hiddenArray[10];

};//InfiniteArray
