/*
   This is an example of an immutable class (i.e.
   this class does not contain any mutator methods).

   BUT, this class has several design errors and it is
   possible to change the contents of a LineSegment object
   after the object has been created.
*/

public class LineSegment
{
   private Point[] endPoints;

   public LineSegment(Point x, Point y)
   {
      endPoints = new Point[2];
      endPoints[0] = x;
      endPoints[1] = y;
   }

   public LineSegment(double x1, double y1, double x2, double y2)
   {
      Point x = new Point(x1, y1);
      Point y = new Point(x2, y2);
      endPoints = new Point[2];
      endPoints[0] = x;
      endPoints[1] = y;
   }

   public Point[] getPoints()
   {
      return endPoints;
   }

   public Point getFirstEndPoint()
   {
      return endPoints[0];
   }

   public Point getSecondEndPoint()
   {
      return endPoints[1];
   }

   public double slope()
   {
      // let the user worry about infinite slope
      return (endPoints[1].getY() - endPoints[0].getY())/(endPoints[1].getX() - endPoints[0].getX());
   }

   public void writeOutput()
   {
      System.out.println( "The first endpoint has:" );
      endPoints[0].writeOutput();
      System.out.println( "The second endpoint has:" );
      endPoints[1].writeOutput();
   }

}//LineSegment