/*
   Use this file to test LineSegment objects.
*/

public class TestLineSegment
{
   public static void main( String[] args )
   {
      LineSegment line = new LineSegment(0,0, 1, 2);

      line.writeOutput();
      System.out.println();

      Point p = line.getFirstEndPoint();

      p.setX(-1);
      p.setY(-1);

      // Even though the data in a LineSegment object is private
      // and immutable, the following output shows that we managed
      // to change the data in the LineSegment object named line.
      line.writeOutput();
      System.out.println();

      // Try to draw a picture that represents as accurately
      // as you can the state of the Java system's memory during
      // the execution of the following three lines of code.
      Point[] backdoor = line.getPoints();

      backdoor[0] = new Point(-2,-2);
      backdoor[1] = new Point(100,200);

      // The following output shows that once again, the data
      // inside the object named line has been mutated (even though
      // LineSegment objects seem to be immutable).
      line.writeOutput();
      System.out.println();

      /*
         Try to fix the problems in LineSegment demonstrated by this program
         by having the methods getFirstEndPoint(), getSecondEndPoint(), and
         getPoints() all return references to copies of the relevant objects.
         In the case of getPoints(), be sure to notice the difference between
         "deep copying" and "shallow copying".
      */

   }//main

}//TestLineSegment