/*
   This program demonstrates how C++ does the calculation of the position
   of an array cell in a two dimensional array.

   C++ uses the formula i*r+j to compute the offset of the cell myArray[i][j]
   in memory, where r is the length of a row of myArray. Notice that for an
   array declared as myArray[4][3], the cell myArray[1][5] evaluates to the
   offset 1*3+5=8, which is the same as the cell myArray[2][2], which resolves
   to the offset 2*3+2=8. So myArray[1][5] and myArray[2][2] are the same cell
   even though myArray[1][5] does not even seem to be a valid array cell.
*/
#include <iostream>
using namespace std;

int main()
{
   // declare a two dimensional array
   int myArray[4][3];

   // initialize the array
   for (int i=0; i<4; i++)
      for(int j=0; j < 3; j++)
         myArray[i][j] = (i+1)*10 + j;


   myArray[1][5] = 99;  // These array indices do not seem to make sense


   // print out the array
   for (int i=0; i<4; i++)
   {
      for(int j=0; j < 3; j++)
        cout << myArray[i][j] << " ";
     cout << endl;
   }

   return 0;
}
